#define R1 51000UL
#define R2_TOP (u32)2E5
#define R2_BTM (u32)2000
#define R2_100 (u32)6400
#define R2_25  (u32)1E5
#define ADC_TOP (u16(0x3ffUL * 1000 / (R2_BTM * 1000 / R1 + 1000))) //985
#define ADC_BTM (u16(0x3ffUL * 1000 / (R2_TOP * 1000 / R1 + 1000))) //208
#define ADC_MIN (u16((1UL<<20)/((-1UL)/R1 - (1<<10)) + 1))    //13
#define ADC_100 (u16((1UL<<10)*1000/(R2_100*1000/R1 + 1000))) //910
#define ADC_25  (u16((1UL<<10)*1000/(R2_25 *1000/R1 + 1000))) //345
//        
#define ADC_TGV ((u16)(((u32)(ADC_100 - ADC_25)<<8)/(MAX_TIME/TSEC))) // 301pt/256s
//         (80/15 ~ 37pt/s)
#define ADC_GMX (u8(ADC_100 - ADC_25)/15)

u8 get_min_adc_time(void)
{
 u8 n = 0;

 do n++; while(!((u8)(((u32)(ADC_100 - ADC_25)*n)/(MAX_TIME/TSEC))));

 return n;
}

u32 get_R2(u16 adc_val)
{
 if(adc_val < ADC_MIN) adc_val = ADC_MIN;

 return R1 * ((1UL<<20) / adc_val - (1<<10)) >> 10;
}

u8 get_T(const u32 ntc_r) //~ 5000    
{
 static const float ntc_b = ((float)1/100 - (float)1/25) / (__iar_log_smallf((float)R2_100 / (float)R2_25));
 static const float k2 = __iar_log_smallf((float)R2_25) * ntc_b - (float)1 / 25;
              float k1 = __iar_log_smallf((float)ntc_r) * ntc_b;

 return u8(1 / (k1 - k2));
}