#define SNBR 100

__root const u8 Bsin_t[SNBR] =
{
	0		,
	8		,
	16	,
	23	,
	31	,
	39	,
	47	,
	55	,
	63	,
	71	,
 78	,
 86	,
 93	,
 101,
 108,
 115,
 122,
 129,
 136,
 143,
 149,
 156,
 162,
 168,
 174,
 180,
 185,
 191,
 196,
 201,
 206,
 210,
 215,
 219,
 223,
 227,
 230,
 234,
 237,
 239,
 242,
 244,
 246,
 248,
 250,
 251,
 252,
 253,
 254,
 254,
 255,
 254,
 254,
 253,
 252,
 251,
 250,
 248,
 246,
 244,
 242,
 239,
 237,
 234,
 230,
 227,
 223,
 219,
 215,
 210,
 206,
 201,
 196,
 191,
 185,
 180,
 174,
 168,
 162,
 156,
 149,
 143,
 136,
 129,
 122,
 115,
 108,
 101,
 93	,
 86	,
 78	,
 71	,
 63	,
 55	,
 47	,
 39	,
 31	,
 23	,
 16	,
 8
};

u8 Sin_step;

void beep(volatile u16* beep_tim, const u16 frq=3000, u16 time_ms = 350)
{
 ICR1H  = SYSTEM_FRQ/frq >>8;
 ICR1L  = u8(SYSTEM_FRQ/frq);

 TCCR1A = 1<<COM1A1 | 1<<COM1B1 | 1<<COM1B0 | 1<<WGM11; //fast pwm, ICR1 top
 TCCR1B = 1<<WGM13  | 1<<WGM12  | 1<<CS10;  // PSC_0

 if(time_ms < SNBR) time_ms = SNBR;
 Sin_step = (u32)time_ms * ((1UL<<16)/SNBR) >> 16;

 *beep_tim = time_ms;
}

void beep_processing(volatile const u16 beep_tim)
{
 static u8 tcnt;
 static u8 cnt;

 if(!beep_tim)
 {
  TCCR1A = 0;
  TCCR1B = 0;

  OCR1AH = 0;
  OCR1BH = 0;
  OCR1AL = 0;
  OCR1BL = 0;

  tcnt = 0;
  cnt  = 0;
 }
 else
 {
  if(tcnt < SNBR)
  {
   if(cnt < Sin_step-1) cnt++;
   else
   {
    u16 tmp;

    tmp  = ICR1L;
    tmp += ICR1H <<8;
    tmp  = (u32)Bsin_t[tcnt] * tmp >> 8 >> 1;

    OCR1AH = tmp >>8;
    OCR1AL = (u8)tmp;
    OCR1BL = (u8)tmp;

    cnt = 0;
    tcnt++;
   }
  }
 }
}

//      , return true   
bool three_beep(volatile u16* beep_tim, volatile u16* timer)
{
 static u8 stage = 0;

 if(!(*timer))
 {
  if(!stage)
  {
   beep(beep_tim);
  }
  else if(stage == 1)
  {
   *timer = TSEC/5;
  }
  else if(stage == 2)
  {
   beep(beep_tim);
  }
  else if(stage == 3)
  {
   *timer = TSEC/5;
  }
  else if(stage == 4)
  {
   beep(beep_tim);
  }
  else
  {
   stage = 0;

   return 1;
  }

  stage++;
 }

 return 0;
}